;    ;    
; 23.12.2009 
.include "2313def.inc"

.def DC=R18
.def ZERO=R1 ;00
.def ONE =R2 ;FF
.def HOUR_H=R5
.def HOUR_L=R6
.def MIN_H=R7
.def MIN_L=R8

.def SEC=R25
.def MIN=R24
.def HOUR=R23

.cseg
.org 0
	RJMP	RESET
	RETI 		; INT_0
	RETI		; INT_1
	RETI		; Timer1_capt1
	RJMP	TIMER_COMP1
;	RETI
	
TB_DIG:
	;     edhcgafb   edhcgafb
	.db 0b00101000,0b11101110 ;01
	.db 0b00110010,0b10100010 ;23
	.db 0b11100100,0b10100001 ;45
	.db 0b00100001,0b11101010 ;67
	.db 0b00100000,0b10100000 ;89
	.db 0b11111111,0b11111111 ;  
TB_DC:
	;   
	.db 0b10010111,0b10011011
	;   
	.db 0b10110011,0b11010011
;**********************************************************
TIMER_COMP1:
	OUT	PORTB,ONE	;    
	OUT	PORTD,ZERO	;  
	
	LDI	ZL,LOW(TB_DC*2)
	ADD	ZL,DC
	LPM

	LDI	XL,5		;   XH,XL  R5
	CLR	XH
	ADD	XL,DC
	LD	R16,X		;    R5...R8  R16
	
	CP	YL,R20
	CPC	YH,R19
	BRCC	POINT
	CPI	DC,$01
	BRNE	POINT
	CBR	R16,$20		;       0.5 
POINT:	
	OUT	PORTD,R0
	OUT	PORTB,R16	;   
	
	INC	DC
	ANDI	DC,$03		;     
	
COMP1_1:
	IN	R17,OCR1AL
	IN	R16,OCR1AH
	
	SBIW	YL,1
	BRMI	SEC_OUT
	BRNE	COMP1_1_OUT
	
	SUB	R4,R21
	SBC	R3,ZERO		;    OCR1A   R21  
				;   
COMP1_1_OUT:
	ADD	R17,R4
	ADC	R16,R3
	OUT	OCR1AH,R16
	OUT	OCR1AL,R17	;    OCR1A   
	
	RETI
SEC_OUT:
	SET		;  1  
	RETI
;*************************************************
;************************************
RESET:
	LDI	R16,RAMEND
	OUT	SPL,R16		;  
	
	CLR	ZH
	CLR	ZERO

	LDI	R16,0b11111111
	MOV	ONE,R16
	
	OUT	DDRB,R16	;   B
	OUT	PORTB,R16

	OUT	DDRD,R16	;  
	OUT	PORTD,R16
	LDI	R16,0b01101100
	OUT	DDRD,R16	;   D
	LDI	R16,0b00010011
	OUT	PORTD,R16
	
	CLR	DC
;*************************************************
;    12:00
	CLR	SEC		;*
	CLR	MIN		;*
	LDI	HOUR,12		;*
	RJMP	GO_TIME		;*
;    00:00,  (*) 
	RJMP	TIME_BEGIN
;*************************************************
GO:
	CLR	ZH
	CLR	ZERO

	LDI	R16,0b11111111
	MOV	ONE,R16
	
	CLR	DC
	
	LDI	R21,48

	LDI	YH,HIGH(799)
	LDI	YL,LOW(799)	;  

	LDI	XH,HIGH(12500)	;     
	MOV	R3,XH		;  200     
	OUT	OCR1AH,XH
	LDI	XL,LOW(12500)
	MOV	R4,XL
	OUT	OCR1AL,XL
	
	LDI	R19,HIGH(400)
	LDI	R20,LOW(400)	;    
	
	LDI	R16,0b01000000
	OUT	TIMSK,R16	;   Timer1_comp1
	
	LDI	R16,1
	OUT	TCCR1B,R16	;  Fclk
	
	OUT	TIFR,ONE

	CLT
	SEI 			;   
WAIT:
	BRTC	WAIT
	CLI
	CLT	
;**********************************************************
	
	OUT	TCCR1B,ZERO
	OUT	TCNT1H,ZERO
	OUT	TCNT1L,ZERO
	LDI	R16,1
	OUT	TCCR1B,R16
	
KEY_MIN:
	SBIC	PIND,1
	RJMP	KEY_HOUR	;    HOUR
 	INC	MIN		;  MIN
 	CPI	MIN,60
 	BRMI	MIN_60
 	CLR	MIN
MIN_60: 	
KEY_HOUR: 	
	SBIC	PIND,0
	RJMP	INC_TIME
 	INC	HOUR
 	CPI	HOUR,24
 	BRMI	INC_TIME
 	CLR	HOUR
INC_TIME:
	INC	SEC
	CPI	SEC,60
	BRMI	GO_TIME
	CLR	SEC
INC_MIN:
	INC	MIN
	CPI	MIN,60
	BRMI	GO_TIME
	CLR	MIN
INC_HOUR:
	INC	HOUR
	CPI	HOUR,24
	BRMI	GO_TIME
TIME_BEGIN:	
	CLR	SEC
	CLR	MIN
	CLR	HOUR
GO_TIME:
	MOV	R16,HOUR
	RCALL	DIG_HOUR

	MOV	R16,MIN
	RCALL	DIG_MIN
	
	RJMP	GO
;**********************************************************
;**********************************************************
;**********************************************************
;**********************************************************
;**********************************************************
;**********************************************************
DIG_HOUR:
	LDI	R17,10
	CLR	R5		; 
	CLR	R6		; 
	
	MOV	R0,R16
IN1:
	MOV	R16,R0	
	
	SUB	R0,R17
	BRCS	PR_OUT
	INC	R5
	RJMP	IN1
PR_OUT:
	MOV	R6,R16
	TST	R5
	BRNE	IN2
	MOV	R5,R17
IN2:	
	LDI	ZL,LOW(TB_DIG*2)
	ADD	ZL,R5
	LPM
	MOV	R5,R0
	
	LDI	ZL,LOW(TB_DIG*2)
	ADD	ZL,R6
	LPM
	MOV	R6,R0
	
	RET
;*************************************************
DIG_MIN:
	LDI	R17,10
	CLR	R7		; 
	CLR	R8		; 
	
	MOV	R0,R16
MIN1:
	MOV	R16,R0	
	
	SUB	R0,R17
	BRCS	MIN_OUT
	INC	R7
	RJMP	MIN1
MIN_OUT:
	MOV	R8,R16
MIN2:	
	LDI	ZL,LOW(TB_DIG*2)
	ADD	ZL,R7
	LPM
	MOV	R7,R0
	
	LDI	ZL,LOW(TB_DIG*2)
	ADD	ZL,R8
	LPM
	MOV	R8,R0
	
	RET
	
;	END
